"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var helpers_1 = require("../helpers");
var BEMNode_1 = require("./BEMNode");
var settings_1 = require("../context/settings");
exports.BEMElementCreator = function (Component) {
    var BEMNode = BEMNode_1.BEMNodeCreator(Component);
    var BEMElement = function (props) {
        var setting = React.useContext(settings_1.BEMSettingContext);
        var BEM_BlockNames = React.useContext(settings_1.BEMNodeContext).BEM_BlockNames;
        function getNames() {
            var bemBlock = props.bemBlock;
            var elementDelimiter = setting.elementDelimiter;
            var blockNames = bemBlock ? helpers_1.convertBemValueToArray(bemBlock) : BEM_BlockNames;
            var result = [];
            blockNames.forEach(function (blockName) {
                var value = helpers_1.convertBemValueToArray(props.bemName)
                    .map(function (name) { return helpers_1.getStringBemInfo(name, setting); })
                    .filter(function (info) { return helpers_1.checkBemInfoCondition(info, blockName, ''); })
                    .map(function (info) { return "" + blockName + elementDelimiter + info.className; });
                result.push.apply(result, value);
            });
            return result;
        }
        return React.createElement(BEMNode, __assign({ getNames: getNames }, props));
    };
    return BEMElement;
};
