"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var helpers_1 = require("../helpers");
var settings_1 = require("../context/settings");
exports.BEMNodeCreator = function (Component) { return function BEMNode(_a) {
    var forwardedRef = _a.forwardedRef, getNames = _a.getNames, bemMod = _a.bemMod, className = _a.className, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    bemName = _a.bemName, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    bemBlock = _a.bemBlock, props = __rest(_a, ["forwardedRef", "getNames", "bemMod", "className", "bemName", "bemBlock"]);
    var setting = React.useContext(settings_1.BEMSettingContext);
    var stylesObject = React.useContext(settings_1.BEMStyleContext);
    function getClassName(setting) {
        if (!getNames) {
            throw new Error('getNames not implement');
        }
        var names = getNames();
        var mods = helpers_1.convertBemValueToArray(bemMod);
        var classNames = [];
        names.forEach(function (name) { return classNames.push.apply(classNames, helpers_1.addModifiersToClassName(name, mods, setting)); });
        if (className) {
            classNames.push(className);
        }
        return classNames;
    }
    function replaceModulesStyles(classNames) {
        if (!stylesObject) {
            return classNames;
        }
        return classNames.map(function (className) { return stylesObject[className] || className; });
    }
    var classNameWithBem = replaceModulesStyles(getClassName(setting)).join(' ');
    return (React.createElement(Component, __assign({ className: classNameWithBem, forwardedRef: forwardedRef }, props)));
}; };
