import { BemValue, BemInfo, BemSettingI } from './domain';
/**
 * Default setting
 */
export declare const DEFAULT_BEM_SETTING: BemSettingI;
/**
 * Create class name with modifiers
 * @param {string} className
 * @param {string[]} modifiers
 * @param {object} setting
 * @return {string[]}
 */
export declare function addModifiersToClassName(className: string, modifiers?: string[], setting?: BemSettingI): string[];
/**
 * Test bemInfo values by blockName and elementName
 * @param {object} bemInfo
 * @param {string} block
 * @param {string} element
 * @return {bool}
 */
export declare function checkBemInfoCondition(bemInfo: BemInfo, block: string, element?: string): boolean;
/**
 * Create class name with modifiers
 * @param {string} className
 * @param {object} setting
 * @return {object}
 */
export declare function getStringBemInfo(className: string, setting?: BemSettingI): BemInfo;
/**
 * Converts many possible values to one format.
 * return empty array if bemValue is invalid
 * @param {string|object|string[]} bemValue
 * @return {string[]}
 */
export declare function convertBemValueToArray(bemValue: BemValue): string[];
